// This sketch doesn't have a whole lot to do with recursion,
// but because so much of the module has to do with fractals
// I figured it would be a good idea to include an example of
// drawing the Mandelbrot Set.

void setup()
{
  size( 500, 500 );
}

void draw()
{
  loadPixels();
  colorMode( HSB, 100 );
  
  for( int row = 0; row < height; ++row ) {
    for( int col = 0; col < width; ++col ) {
      float xx = map( col, 0, width, -1.9, 0.6 );
      float yy = map( row, 0, height, -1.25, 1.25 );
      
      float a = xx;
      float b = yy;
      boolean escape = false;
      
      for( int idx = 0; idx < 50; ++idx ) {
        if( mag( a, b ) > 2 ) {
          pixels[row*width+col] = color( 2*idx, 100, 100 );
          escape = true;
          break;
        }
        float na = a*a-b*b+xx;
        float nb = 2*a*b+yy;
        a = na;
        b = nb;
      }
      
      if( !escape ) {
          pixels[row*width+col] = color( 0, 0, 0 );
      }
    }
    
    updatePixels();
  }
}
