// A slightly fancy tree of fractal circles controlled by the
// mouse.  Use nested geometric contexts and an explicit variable
// to track the number of recursive levels.

void setup()
{
  size( 500, 500 );
  fill( 0 );
  noStroke();
}

void makeDrawing( int levs )
{
  ellipse( 0, 0, 150, 150 );
  if ( levs > 0 ) {
    pushMatrix();
    translate( 130, -20 );
    rotate( map( mouseY, 0, height, 0, radians( 90 ) ) );
    scale( map( mouseX, 0, width, 0, 1 ) );
    makeDrawing( levs - 1 );
    popMatrix();

    pushMatrix();
    rotate( radians( -80 ) );
    translate( 100, -90 );
    rotate( map( mouseY, 0, height, 0, radians( 90 ) ) );
    scale( map( mouseX, 0, width, 0, 1 ) );
    makeDrawing( levs - 1 );
    popMatrix();
  }
}

void draw()
{
  background( 255 );
  translate( 100, 350 );
  makeDrawing( 10 );
}

