// A Processing implementation of the legendary BASIC program
// 10 PRINT CHR$(205.5+RND(1)); : GOTO 10
// see http://nickm.com/trope_tank/10_PRINT_121114.pdf

// Add in a few fancy features -- use a fixed random seed to
// make sure the design doesn't change from frame to frame.
// But change the random threshold to adjust the balance 
// between the two slash orientations.

int current_seed = 0;

void setup()
{
  size( 600, 400 );
  strokeCap( ROUND );
  strokeWeight( 7 );
  stroke( 0 );
  noFill();
}

void draw()
{
  randomSeed( current_seed );
  float t = norm( mouseX, 0, width );
  background( 255 );
  for( int y = 0; y < height; y += 20 ) {
    for( int x = 0; x < width; x += 20 ) {
      if( random(1) <= t ) {
        line( x, y, x + 20, y + 20 );
      } else {
        line( x + 20, y, x, y + 20 );
      }
    }
  }
}

void keyPressed()
{
  current_seed = millis();
}
