// An alternate version of TenPrint that uses the noise()
// function instead of the random() function.  This has the
// side effect that you can also scale the noise function to
// control how "spatially coherent" the random field is.

void setup()
{
  size( 600, 400 );
  strokeCap( ROUND );
  strokeWeight( 7 );
  stroke( 0 );
  noFill();
}

void draw()
{
  float t = norm( mouseX, 0, width );
  float sc = map( mouseY, 0, height, 0, 2 );
  background( 255 );
  for( int y = 0; y < height; y += 20 ) {
    for( int x = 0; x < width; x += 20 ) {
      if( noise(x*sc,y*sc) <= t ) {
        line( x, y, x + 20, y + 20 );
      } else {
        line( x + 20, y, x, y + 20 );
      }
    }
  }
}
