// Combine the random variation of TenPrintNoise with the
// infinite scrolling of Qbert, and you get a kind of 
// infinite Op Art field.  By the way -- move the mouse
// all the way to the left edge of the window.  Now: which
// direction are the lines moving?  Left?  Up?  Diagonal?

float ty = 0.0;

void setup()
{
  size( 600, 400 );
  strokeCap( ROUND );
  strokeWeight( 7 );
  stroke( 0 );
  noFill();
}

void draw()
{
  float t = norm( mouseX, 0, width );
  float sc = map( mouseY, 0, height, 0, 2 );
  background( 255 );
  for( int y = int(ty%20); y < height; y += 20 ) {
    for( int x = 0; x < width; x += 20 ) {
      if( noise(x*sc,(y-ty)*sc) <= t ) {
        line( x, y, x + 20, y + 20 );
      } else {
        line( x + 20, y, x, y + 20 );
      }
    }
  }
  ty -= 1;
}
